# The code calculates the incidence matrix of the expanded design from a given labeled 
# {3,4}-GDD of type g_u and index la with all blocks of size 3 in r1 3-pcs
# all conditions on the incidence matrix are checked


# ------- SET ALL THE IMPORTANT FIXED PARAMETERS OF THE LABELED DESIGN. -------
# These should be set by the user.

filename <- "3_4LGDD16ot1_9.r3_58.txt"

la=16
g=1
u=9
r1 = 58      # intern r1 coresponds to k1=3 and therefore extern r3

# ------- END TO EDIT



k1 = 3
k2 = 4
k = max(k1,k2) 
v = g*u
klgr1 = v / k1
b1 = v*r1/k1
b2 = (la*v*(v-g)/2 - r1*v) / 6  	# only for k1=3, k2=4
r2 = b2*k2/v

r=r1+r2
r
b = b1+b2

b1
b2
r2


blma <- rep(0,k*b)
blma <- matrix(blma, k, b)       # block matrix

Label <- rep(0,k*(k-1)*b/2)
Label <- matrix(Label, k*(k-1)/2, b, byrow=T)      # matrix of Labels

# read data and calculate above matrices
x <- paste(readLines(filename), collapse = " ")
x <- gsub("[[:punct:]]+", " ",x)
x <- sub("^ +", "", sub(" +$", "", x))
x <- as.numeric(unlist(strsplit(x, split="[ ]+")))

zl<-1
if(b1>0)
  for(j in 1:b1) {
        for(i in 1:k1) {
          blma[i,j] <- x[zl]
          zl <- zl + 1
          }
        for(i in 1:(k1*(k1-1)/2)) {
          Label[i,j] <- x[zl]
          zl <- zl + 1
          }
  }
if(b2>0)
  for(j in (b1+1):b) {
        for(i in 1:k2) {
          blma[i,j] <- x[zl]
          zl <- zl + 1
          }
        for(i in 1:(k2*(k2-1)/2)) {
          Label[i,j] <- x[zl]
          zl <- zl + 1
          }
  }

vec <- c(0:(la-1))
cm <- rep(0,la*la)
cm <- matrix(cm, la, la)
for(j in 0:(la-1)) cm[,j+1] <- (vec+j) %% la + 1



# create the expanded incidence matrix m.out
v.out <- v*la
b.out <- b*la
m.out <- rep(0,v.out*b.out)
m.out <- matrix(m.out, v.out, b.out)

#  m.out fill
if(b1>0)
  for(j in 0:(b1-1)) {
	zl<-0
	for(i1 in 1:la) m.out[la*(blma[1,j+1]-1) +i1, la*j +i1] <- 1
	zl <- zl+1

	for(i in 2:k1) {
	      for(i1 in 1:la) m.out[la*(blma[i,j+1]-1) + cm[Label[zl,j+1] +1, i1], la*j +i1] <- 1
	      zl <- zl+1
       }

  }
					
if(b2>0)
  for(j in b1:(b-1)) {
	zl<-0
	for(i1 in 1:la) m.out[la*(blma[1,j+1]-1) +i1, la*j +i1] <- 1
	zl <- zl+1
	for(i in 2:k2) {
	for(i1 in 1:la) m.out[la*(blma[i,j+1]-1) + cm[Label[zl,j+1] +1, i1], la*j +i1] <- 1
	zl <- zl+1
        }
  }


# check all conditions on the incidence matrix m.out

v.out  = v*la
g.out  = g*la
la.out = 1
klgr1.out = v.out/k1
klgr1.out


b1.out = klgr1.out*r1
b1.out
b2.out = b2*la
b2.out
r2 = b2.out*k2/v.out
b.out = b1.out+b2.out
r=r1+r2
r


ri <- apply(m.out, 1, sum)

# all row-sums must be r
ri		
min(ri)
max(ri)

R <- rep(0, v.out*r)
R <- matrix(R, v.out, r)
for(i in 1:v.out) 
  if(b1.out>0) for(j1 in 0:(r1-1))
		for(j2 in 1:klgr1.out) R[i,j1+1] <- R[i,j1+1] + m.out[i, j1*klgr1.out + j2]
 
max(R)
apply(R>1, 2, sum)      # checked 3-pc; needed r nulls



kj <- apply(m.out, 2, sum)

# b1 times 3 and b2 times 4; b1 and b2 see above
kj			

min(kj)			# 3
max(kj)			# 4



M <- rep(0, b.out*v.out/g.out)
M <- matrix(M, v.out/g.out, b.out)
for(i in 1:(v.out/g.out)) {		
	for(i1 in 1:g.out) M[i,] <- M[i,] + m.out[(i-1)*g.out+i1,]
}
max(M)         # checked group condition; have to be 1
# apply(M>1, 2, sum)




H <-  crossprod(t(m.out)) - r * diag(v.out)
max(H) 
I <- 1:(v.out*v.out)
I[H>la.out]         	# checked pair condition; 
			# have to be integer(0)
			# no pair exists more than la.out=1 times			

